<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class ImpactoManutFactory {
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function inserirImpacto($parametros) {

        $sql = "INSERT INTO FCM_IMPACTOMANUT(NRIMPACTOMANUT, NMIMPACTOMANUT, NRPRIORIDADEMANUTPADR, DTINCLUSAO)
                VALUES (:NRIMPACTOMANUT, :NMIMPACTOMANUT, :NRPRIORIDADEMANUTPADR, SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }
    
    public function getInformacoesImpacto() {
        
        $sql = "SELECT I.NRIMPACTOMANUT, I.NMIMPACTOMANUT, P.NMPRIORIDADEMANUT, PRI.NMPRIORIDADEMANUT AS NMPRIORIDADEPADRAO
                    FROM FCM_IMPACTOMANUT I
                    LEFT JOIN FCM_PRIORIDADEMANUT P
                    ON P.NRPRIORIDADEMANUT = I.NRPRIORIDADEMANUTPADR
                    LEFT JOIN FCM_RELPRIORIDADEIMPACTO R
                    ON R.NRIMPACTOMANUT = I.NRIMPACTOMANUT
                   LEFT JOIN FCM_PRIORIDADEMANUT PRI
                   ON PRI.NRPRIORIDADEMANUT = R.NRPRIORIDADEMANUT";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();      
    }
    
    public function getImpactoManutencao() 
    {
        $sql = "SELECT NRIMPACTOMANUT, NMIMPACTOMANUT
                FROM FCM_IMPACTOMANUT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}

?>