import {
    IDictionary, Http,
} from '@zeedhi/core';
import { ECharts } from '@zeedhi/zd-echarts';

export class DashboardController {
    public async dataBaseChartPie({ component }: { component: ECharts }) {
        await Http.get('/dataBaseChartPie').then((response: IDictionary) => {
            const newOptions = { ...component.options };
            if (response.data.length) {
                response.data.forEach((dados: IDictionary) => {
                    const dado = {
                        name: dados.NMATIVIDADE,
                        value: dados.QUANTIDADE,
                        itemStyle: {
                            color: dados.DSCORIDATIVIDADE,
                        },
                    };
                    newOptions.series[0].data.push(dado);
                });
                component.setOption(newOptions);
            } else {
                const dado = {
                    name: 'Não há dados',
                    value: 100,
                    itemStyle: {
                        color: '#57737a',
                    },
                };
                newOptions.series[0].data.push(dado);
                component.setOption(newOptions);
            }
        });
    }

    public async dataBaseChartBar({ component }: { component: ECharts }) {
        Http.get('/dataBaseChartBar').then((response: IDictionary) => {
            const newOptions = { ...component.options };
            if (response.data.length) {
                response.data.forEach((dados: IDictionary) => {
                    newOptions.xAxis.data.push(dados.NMATIVIDADE);
                    const dado = {
                        value: dados.QUANTIDADE,
                        itemStyle: {
                            color: dados.DSCORIDATIVIDADE,
                        },
                    };
                    newOptions.series[0].data.push(dado);
                });
                component.setOption(newOptions);
            } else {
                newOptions.xAxis.data.push('Não há dados');
                newOptions.series[0].data.push(100);
                newOptions.color = '#57737a';
                component.setOption(newOptions);
            }
        });
    }
}
